--clients_statements.ex



--------------------------------------------------------------------------------------------------
procedure statement_ordered_by_patient(atom from_date_n, atom to_date_n,
                                        sequence from_date_seq, sequence to_date_seq,
                                        integer DW, integer DP,
                                        sequence patientlist)
--get all the notes
--select out those in required range

--------------------------------------------------------------------------------------------------
sequence data, cmd, notes_range
atom calc_date, s_tot_wrk, s_tot_paid, s_tot_vat, gr_tot_vat, gr_tot_wrk, gr_tot_paid
integer cur_month, cur_year, fp, s_count
sequence cur_moyear_str, start_date_str, start_date_seq
sequence s_billet, s_tmp
integer S_DATE,
        S_PAT,
        S_NOTE,
        S_VAT,
        S_AMT,  --amount - work or payment
                --if payment, VAT doesn't matter
        S_TYPE,
        PA_PRES_STATEMENT
        
s_tmp = repeat({}, 6)
s_billet = {}
S_DATE = 1
S_PAT = 2
S_NOTE = 3
S_VAT = 4
S_AMT = 5
S_TYPE = 6

gr_tot_wrk = 0
gr_tot_vat = 0
gr_tot_paid = 0

PA_PRES_STATEMENT = PA_TATTOO

cmd = sprintf("SELECT * FROM Notes WHERE client_no = %d " , {CurClient[CL_CLIENT_NO]})
cmd = cmd & "and (type like 'P%' or type like 'S%' or type like 'D%' or type like 'A%') "
data = query_database("xnotes.sql", cmd)

--now step through each of the patients on the patientlist
--first reset one of the unused items on the patientlist, as will be using this to indicate
--the patients presence on the statement
for i = 1 to length(patientlist) do
        patientlist[i][PA_PRES_STATEMENT] = 0
end for

notes_range = {}
for i = 2 to length(data) do
        calc_date = dateStrtoJdays(data[i][N_DATE])
        if calc_date >= from_date_n and calc_date <= to_date_n then
                
                notes_range = append(notes_range, data_validate_note(data[i]))
                
                for j = 1 to length(patientlist) do
                        if strtoval(patientlist[j][PA_PATIENT_NO]) = notes_range[$][N_PATIENT_NO] then            
                                patientlist[j][PA_PRES_STATEMENT] = TRUE
                                exit
                        end if          
                end for
        end if
end for

--each of the patients that has a presence on the notes list is now flagged
--step through the patients

for i = 1 to length(patientlist) do
        s_tot_vat = 0
        s_tot_wrk = 0
        s_tot_paid = 0

        if patientlist[i][PA_PRES_STATEMENT] = TRUE then
                --add a new billet line - patient details
                s_billet = append(s_billet, s_tmp)
                s_billet[$][S_DATE] = "--"
                s_billet[$][S_NOTE] = patientlist[i][PA_NAME] 
                s_billet[$][S_TYPE] = "Tname"
                s_billet[$][S_AMT]  = 0
                s_billet[$][S_VAT] = 0
                s_billet = append(s_billet, s_tmp)
                s_billet[$][S_DATE] = "--"
                s_billet[$][S_NOTE] = repeat('=', length(remove_trailing_spaces(patientlist[i][PA_NAME]))) 
                s_billet[$][S_TYPE] = "Tname"
                s_billet[$][S_AMT]  = 0
                s_billet[$][S_VAT] = 0
                
                --gather notes
                for j = 1 to length(notes_range) do
                        if strtoval(patientlist[i][PA_PATIENT_NO]) = notes_range[j][N_PATIENT_NO] then                          
                                if notes_range[j][N_TYPE][1] != 'P' then
                                        if DW = TRUE then
                                                --add it to the billet                        
                                                s_billet = append(s_billet, s_tmp)
                                                s_billet[$][S_DATE] = notes_range[j][N_DATE]
                                                s_billet[$][S_NOTE] = notes_range[j][N_NOTE] 
                                                s_billet[$][S_VAT]  = notes_range[j][N_VAT]
                                                s_billet[$][S_AMT]  = notes_range[j][N_FEES] + notes_range[i][N_DRUGS] 
                                                s_billet[$][S_TYPE] = notes_range[j][N_TYPE]
                                        end if
                                                                        
                                        s_tot_vat += notes_range[j][N_VAT]
                                        s_tot_wrk += notes_range[j][N_FEES] + notes_range[j][N_DRUGS] 
                                        
                                        gr_tot_vat += notes_range[j][N_VAT]
                                        gr_tot_wrk += notes_range[j][N_FEES] + notes_range[j][N_DRUGS] 
                                else
                                        if DP = TRUE then
                                                s_billet = append(s_billet, s_tmp)
                                                s_billet[$][S_DATE] = notes_range[j][N_DATE]
                                                s_billet[$][S_NOTE] = notes_range[j][N_NOTE] 
                                                s_billet[$][S_TYPE] = notes_range[j][N_TYPE]
                                                s_billet[$][S_AMT]  = notes_range[j][N_TOTAL] 
                                                s_billet[$][S_VAT] = 0
                                        end if
                                        s_tot_paid += notes_range[j][N_TOTAL]
                                        gr_tot_paid += notes_range[j][N_TOTAL]
                                end if
                        end if
                end for
                
                --at end of each note gathering, add on subtotals
                s_billet = append(s_billet, s_tmp)
                s_billet[$][S_DATE] = "--"
                s_billet[$][S_NOTE] = "Total work" 
                s_billet[$][S_TYPE] = "Twork"
                s_billet[$][S_AMT]  = s_tot_wrk
                s_billet[$][S_VAT] = s_tot_vat
                s_billet = append(s_billet, s_tmp)
                s_billet[$][S_DATE] = "--"
                s_billet[$][S_NOTE] = "Total paid" 
                s_billet[$][S_TYPE] = "Tpaid"
                s_billet[$][S_AMT]  = s_tot_paid
                s_billet[$][S_VAT] = 0
         
         end if
end for

--produce the file
fp = open(sprintf("statement_%d", {CurClient[CL_CLIENT_NO]}), "w")

--Owner details - beautify this later
printf(fp, "Statement for %s %s %s\n", {CurClient[CL_TITLE], CurClient[CL_FIRST_NAME], CurClient[CL_SURNAME]})
printf(fp, "              %s\n", {CurClient[CL_ADDRESS1]})
printf(fp, "              %s\n", {CurClient[CL_ADDRESS2]})
printf(fp, "              %s\n", {CurClient[CL_ADDRESS3]})
printf(fp, "              %s\n", {CurClient[CL_ADDRESS4]})
printf(fp, "              %s\n\n", {CurClient[CL_POSTCODE]})

for i = 1 to length(s_billet) do
        if s_billet[i][S_TYPE][1] = 'T' then
                if s_billet[i][S_TYPE][2] = 'n' then
                        printf(fp, "%s\n", {s_billet[i][S_NOTE]})
                
                elsif s_billet[i][S_TYPE][2] = 'w' then
                        printf(fp, "----------------------------------------------------------------------\n", {})
                        printf(fp, "%-8.8s  %-40.40s %8.2f %8.8s\n", {" ", s_billet[i][S_NOTE],  s_billet[i][S_AMT] + s_billet[i][S_VAT], " "})         
                                       
                elsif s_billet[i][S_TYPE][2] = 'p' then
                        printf(fp, "%-8.8s  %-40.40s %8.8s %8.2f\n", {"", s_billet[i][S_NOTE], " ",  s_billet[i][S_AMT] + s_billet[i][S_VAT]})         
                       printf(fp, "======================================================================\n\n", {})                                            
                end if
        end if

        if  s_billet[i][S_TYPE][1] = 'P' then
                printf(fp, "%-8.8s  %-40.40s %8.8s %8.2f\n", {s_billet[i][S_DATE], s_billet[i][S_NOTE], " ",  s_billet[i][S_AMT]})         
        elsif s_billet[i][S_TYPE][1] = 'S' or  s_billet[i][S_TYPE][1] = 'D' or  s_billet[i][S_TYPE][1] = 'A' then
                printf(fp, "%-8.8s  %-40.40s %8.2f %8.8s\n", {s_billet[i][S_DATE], s_billet[i][S_NOTE],  s_billet[i][S_AMT] + s_billet[i][S_VAT], " "})           
        end if
end for

--finish up with the grand totals of everything
printf(fp, "%-8.8s  %-40.40s %8.2f %8.8s\n", {" ", "Grand total work done",  gr_tot_wrk + gr_tot_vat, " "})           
printf(fp, "%-8.8s  %-40.40s %8.8s %8.2f\n", {" ", "Grand total payments", " ",  gr_tot_paid})         

close (fp)

system_view_file(sprintf("statement_%d", {CurClient[CL_CLIENT_NO]}))

if upper(get_yn_box("Print the statement")) = 'Y' then
        printers_print_file(sprintf("statement_%d", {CurClient[CL_CLIENT_NO]}), PR_STATEMENT)
end if
unlink(sprintf("statement_%d", {CurClient[CL_CLIENT_NO]}))


end procedure



--------------------------------------------------------------------------------------------------
procedure statement_ordered_by_month(atom from_date_n, atom to_date_n,
                                        sequence from_date_seq, sequence to_date_seq,
                                        integer DW, integer DP,
                                        sequence patientlist)
--get all the notes
--select out those in required range

--------------------------------------------------------------------------------------------------
sequence data, cmd, notes_range
atom calc_date, s_tot_wrk, s_tot_paid, s_tot_vat, gr_tot_vat, gr_tot_wrk, gr_tot_paid
integer cur_month, cur_year, fp, s_count
sequence cur_moyear_str, start_date_str, start_date_seq
sequence s_billet, s_tmp
integer S_DATE,
        S_PAT,
        S_NOTE,
        S_VAT,
        S_AMT,  --amount - work or payment
                --if payment, VAT doesn't matter
        S_TYPE
        
s_tmp = repeat({}, 6)
s_billet = {}
S_DATE = 1
S_PAT = 2
S_NOTE = 3
S_VAT = 4
S_AMT = 5
S_TYPE = 6

gr_tot_wrk = 0
gr_tot_vat = 0
gr_tot_paid = 0

cmd = sprintf("SELECT * FROM Notes WHERE client_no = %d " , {CurClient[CL_CLIENT_NO]})
cmd = cmd & "and (type like 'P%' or type like 'S%' or type like 'D%' or type like 'A%') "
data = query_database("xnotes.sql", cmd)

notes_range = {}
for i = 2 to length(data) do
        calc_date = dateStrtoJdays(data[i][N_DATE])
        if calc_date >= from_date_n and calc_date <= to_date_n then
                
                notes_range = append(notes_range, data_validate_note(data[i]))
        end if
end for

--collect data for each required month - how!!!!!!
--will take too long to loop through for every possible date,
--will loop through months, incrementing months and years separately

--Date type is ymd
--chances are first note is going to be earliest date

start_date_seq = notes_range[1][N_DATE]
start_date_seq = datestrtoDate(start_date_seq)
cur_year = start_date_seq[1]
cur_month = start_date_seq[2]

cur_moyear_str = ""

while 1 do
        cur_moyear_str = sprintf("%02d/%d", {cur_month, cur_year})

        s_tot_vat = 0
        s_tot_wrk = 0
        s_tot_paid = 0
        --date str in notes_range sequence?
        for i = 1 to length(notes_range) do
                if match(cur_moyear_str, notes_range[i][N_DATE]) > 0 then
                        
                        if notes_range[i][N_TYPE][1] != 'P' then
                                if DW = TRUE then
                                        --add it to the billet                        
                                        s_billet = append(s_billet, s_tmp)
                                        s_billet[$][S_DATE] = notes_range[i][N_DATE]
                                        s_billet[$][S_NOTE] = notes_range[i][N_NOTE] 
                                        s_billet[$][S_VAT]  = notes_range[i][N_VAT]
                                        s_billet[$][S_AMT]  = notes_range[i][N_FEES] + notes_range[i][N_DRUGS] 
                                        s_billet[$][S_TYPE] = notes_range[i][N_TYPE]
                                        
                                        for j = 1 to length(patientlist) do
                                                if strtoval(patientlist[j][PA_PATIENT_NO]) = notes_range[i][N_PATIENT_NO] then
                                                        s_billet[$][S_PAT] = patientlist[j][PA_NAME]
                                                end if                        
                                        end for
                                end if

                                s_tot_vat += notes_range[i][N_VAT]
                                s_tot_wrk += notes_range[i][N_FEES] + notes_range[i][N_DRUGS] 
                                
                                gr_tot_vat += notes_range[i][N_VAT]
                                gr_tot_wrk += notes_range[i][N_FEES] + notes_range[i][N_DRUGS] 
                        else
                                if DP = TRUE then
                                        s_billet = append(s_billet, s_tmp)
                                        s_billet[$][S_DATE] = notes_range[i][N_DATE]
                                        s_billet[$][S_NOTE] = notes_range[i][N_NOTE] 
                                        s_billet[$][S_TYPE] = notes_range[i][N_TYPE]
                                        s_billet[$][S_AMT]  = notes_range[i][N_TOTAL] 
                                        s_billet[$][S_VAT] = 0
                                end if

                                s_tot_paid += notes_range[i][N_TOTAL]
                                gr_tot_paid += notes_range[i][N_TOTAL]
                        end if
                        
                end if
        end for

        if s_tot_wrk != 0 or s_tot_paid != 0 then              
                --add on separator
                s_billet = append(s_billet, s_tmp)
                s_billet[$][S_DATE] = "--/" &  cur_moyear_str
                s_billet[$][S_TYPE] = "-"
                        
                --add on totals lines
                s_billet = append(s_billet, s_tmp)
                s_billet[$][S_DATE] = "--/" &  cur_moyear_str
                s_billet[$][S_NOTE] = "Total work"
                s_billet[$][S_VAT]  = s_tot_vat
                s_billet[$][S_AMT]  = s_tot_wrk
                s_billet[$][S_TYPE] = "TW"
                
                s_billet = append(s_billet, s_tmp)
                s_billet[$][S_DATE] = "--/" &  cur_moyear_str
                s_billet[$][S_NOTE] = "Total payments" 
                s_billet[$][S_VAT]  = 0
                s_billet[$][S_AMT]  = s_tot_paid
                s_billet[$][S_TYPE] = "TP"
        
                --add on terminator
                s_billet = append(s_billet, s_tmp)
                s_billet[$][S_DATE] = "--/" &  cur_moyear_str
                s_billet[$][S_TYPE] = "="
        end if

        --increment month and year, and exit if gone over
        cur_month += 1
        if cur_month > 12 then
                cur_year += 1
                cur_month = 1   
        end if
        if cur_year > to_date_seq[1] or (cur_year = to_date_seq[1] and cur_month > to_date_seq[2]) then
                exit
        end if          

end while

--lets just see what we have
--fp = open("cl_stats", "w")
--for i = 1 to length(s_billet) do
--        printf(fp, "%s %s %8.2f\n" , {s_billet[i][S_DATE], s_billet[i][S_NOTE], s_billet[i][S_AMT] + s_billet[i][S_VAT]})
--end for
--close(fp)

--put into a printable form
s_count = 1
fp = open(sprintf("statement_%d", {CurClient[CL_CLIENT_NO]}), "w")

--Owner details - beautify this later
printf(fp, "Statement for %s %s %s\n", {CurClient[CL_TITLE], CurClient[CL_FIRST_NAME], CurClient[CL_SURNAME]})
printf(fp, "              %s\n", {CurClient[CL_ADDRESS1]})
printf(fp, "              %s\n", {CurClient[CL_ADDRESS2]})
printf(fp, "              %s\n", {CurClient[CL_ADDRESS3]})
printf(fp, "              %s\n", {CurClient[CL_ADDRESS4]})
printf(fp, "              %s\n\n", {CurClient[CL_POSTCODE]})

while 1 do
        if s_count > length(s_billet) then exit end if

        --put on the date of the current 1st one of the month
        --extract month from date
        cur_month = strtoval(s_billet[s_count][S_DATE][4..$])
        printf(fp, "%s %d\n==================\n", {MONTHS[cur_month],strtoval(s_billet[s_count][S_DATE][7..$]) }) 
        
        --can now start going through breakdown bits of billet
        while 1 do
                if  s_billet[s_count][S_TYPE][1] = 'P' then
                        printf(fp, "%-8.8s %-40.40s %8.8s %8.2f\n", {"", s_billet[s_count][S_NOTE], " ",  s_billet[s_count][S_AMT]})         
                elsif s_billet[s_count][S_TYPE][1] = 'S' or  s_billet[s_count][S_TYPE][1] = 'D' or  s_billet[s_count][S_TYPE][1] = 'A' then
                        printf(fp, "%-8.8s %-40.40s %8.2f %8.8s\n", {s_billet[s_count][S_PAT], s_billet[s_count][S_NOTE],  s_billet[s_count][S_AMT] + s_billet[s_count][S_VAT], " "})           
                
                elsif  s_billet[s_count][S_TYPE][1] = '-' then
                        --totals lines encountered
                        --put on the first separator
                        printf(fp, "----------------------------------------------------------------------\n", {})
                        s_count += 1
                        printf(fp, "%-8.8s %-40.40s %8.2f %8.8s\n", {"", s_billet[s_count][S_NOTE],  s_billet[s_count][S_AMT] + s_billet[s_count][S_VAT], " "})         
                        s_count += 1
                        printf(fp, "%-8.8s %-40.40s %8.8s %8.2f\n", {"", s_billet[s_count][S_NOTE], " ",  s_billet[s_count][S_AMT] + s_billet[s_count][S_VAT]})         
                        s_count += 1
                        printf(fp, "======================================================================\n\n", {})                                            
                
                        --exit loop as passed a terminator
                        exit
                end if
                s_count += 1                      
        end while

        s_count += 1        
        --do it again!
end while

--finish up with the grand totals of everything
printf(fp, "%-8.8s %-40.40s %8.2f %8.8s\n", {" ", "Grand total work done",  gr_tot_wrk + gr_tot_vat, " "})           
printf(fp, "%-8.8s %-40.40s %8.8s %8.2f\n", {" ", "Grand total payments", " ",  gr_tot_paid})         


close(fp)

system_view_file(sprintf("statement_%d", {CurClient[CL_CLIENT_NO]}))

if upper(get_yn_box("Print the statement")) = 'Y' then
        printers_print_file(sprintf("statement_%d", {CurClient[CL_CLIENT_NO]}), PR_STATEMENT)
end if
unlink(sprintf("statement_%d", {CurClient[CL_CLIENT_NO]}))

end procedure


--------------------------------------------------------------------------------------------------
global procedure client_statements(sequence patientlist)
--CurClient is after all global!
--------------------------------------------------------------------------------------------------
sequence result, from_date, to_date, from_date_seq, to_date_seq
atom from_date_n, to_date_n
integer PTF, MTF, can_exit, DW, DP

from_date = "01/01/1990"
to_date = DateToStr(nowDate())
PTF = TRUE
MTF = FALSE
DP = TRUE       --detailed payments
DW = TRUE       --detailed work
can_exit = FALSE

SetSize(10,40)

while 1 do
        result = MixedForm("Statement selection", {YELLOW, GREEN}, 5, 20,
                                {
                                {MF_CHECK, 3,1, PTF, "Order by patient"},
                                {MF_CHECK, 4,1, MTF, "Order by month"},

                                {MF_LABEL, 6,1,"From date "},
                                {MF_LABEL, 7,1, "To date  "},

                                {MF_TEXT, 6,11, 13, from_date},
                                {MF_TEXT, 7, 11,13, to_date},

                                {MF_LABEL, 5, 25, "Show detailed"},
                                {MF_CHECK, 6,25, TRUE, "Work"},
                                {MF_CHECK, 7,25, TRUE, "Payment"},


                                {MF_BUTTON, 9, 3, 13, 1, "    Ok     "},
                                {MF_BUTTON, 9, 20, 13, 2, "  Cancel   "}

                                }
                                )

        if result[11] = 2 then exit end if

        PTF = result[1]
        MTF = result[2]
        DW = result[8]
        DP = result[9]

        from_date = remove_trailing_spaces(result[5])
        to_date = remove_trailing_spaces(result[6])

        --valid dates?
        if utils_validDate(from_date) = TRUE and utils_validDate(to_date) = TRUE and
                PTF != MTF then
                        exit
        elsif utils_validDate(from_date) = FALSE or utils_validDate(to_date) = FALSE then
                        VOID = get_yn_box("Invalid dates!")
        elsif PTF = MTF and PTF = FALSE then
                        VOID = get_yn_box("Choose a statement option!")
        elsif PTF = MTF and PTF = TRUE then
                        VOID = get_yn_box("Choose only one statement option!")
        end if

end while


from_date_n = dateStrtoJdays(from_date)
to_date_n = dateStrtoJdays(to_date)

from_date_seq = datestrtoDate(from_date)
to_date_seq = datestrtoDate(to_date)

if result[10] = 1 then
        if PTF = TRUE then
                statement_ordered_by_patient(from_date_n, to_date_n, from_date_seq, to_date_seq, DW, DP, patientlist)
        else
                statement_ordered_by_month(from_date_n, to_date_n, from_date_seq, to_date_seq, DW, DP, patientlist)
        end if
end if

end procedure
