--clinical notes keycard functions in here
--CurClient / CurPatient are ALWAYS set here, so theoretically
--have to do v little lookup
--Notes is also global

--to do
--L list notes                  - done
--M make appointment            - done
--R reminders
--B bill today             - just printing
--C change login                - done
--E estimates                   - done in separate estimates.ex
--H history
--J forms
--S statement
--W weight                      --analysis to do

------------------------------------------------------------------------------------
global function keycard_keycard()
--mvwaddstr(w,1,1,"A - add text               J - forms                   S - statement");
--mvwaddstr(w,2,1,"B - bill today             K - key card                T - lab tests");
--mvwaddstr(w,3,1,"C - change login           L - list notes              U - user show/hide");
--mvwaddstr(w,4,1,"D - cl + ptnt label        M - make appointment        V - ");
--mvwaddstr(w,5,1,"E - estimates              N -                         W - weight");
--mvwaddstr(w,6,1,"F - freehand lbl           O -                         X - archived notes");
--mvwaddstr(w,7,1,"G - graphics               P - patient popup           Y - ");
--mvwaddstr(w,8,1,"H - history                Q - quit patient            Z - recind deceased");
--mvwaddstr(w,9,1,"I - priced items           R - reminders ");           
--mvwaddstr(w,10,1,"1 - Old style text");
------------------------------------------------------------------------------------
sequence box
integer offsetrow, offsetcol
object key

offsetrow = floor(SCREEN_LINES/2) - 7
offsetcol = floor(SCREEN_COLS/2) - 38
box = DefaultBox
SetSize(14, 76)
position(offsetrow, offsetcol)
SetColors(YELLOW, BLACK)

box = PlainBox(DefaultBox)
printcolor({offsetrow+1, offsetcol+1}, {YELLOW, BLACK},  "A - add text               J - forms                   S - statement")
printcolor({offsetrow+2, offsetcol+1}, {YELLOW, BLACK},  "B - bill today             K - key card                T - lab tests")
printcolor({offsetrow+3, offsetcol+1}, {YELLOW, BLACK},  "C - change login           L - list notes              U - notes search")
printcolor({offsetrow+4, offsetcol+1}, {YELLOW, BLACK},  "D - cl + ptnt label        M - make appointment        V - ")
printcolor({offsetrow+5, offsetcol+1}, {YELLOW, BLACK},  "E - estimates              N -                         W - weight")
printcolor({offsetrow+6, offsetcol+1}, {YELLOW, BLACK},  "F - freehand lbl           O -                         X - archived notes")
printcolor({offsetrow+7, offsetcol+1}, {YELLOW, BLACK},  "G - graphics               P - patient popup           Y - ")
printcolor({offsetrow+8, offsetcol+1}, {YELLOW, BLACK},  "H - history                Q - quit patient            Z - recind deceased")
printcolor({offsetrow+9, offsetcol+1}, {YELLOW, BLACK},  "I - priced items           R - reminders ")
printcolor({offsetrow+10, offsetcol+1}, {YELLOW, BLACK}, "1 - Temp / wt convert      2 - Stop watch")
printcolor({offsetrow+11, offsetcol+1}, {YELLOW, BLACK}, "")
printcolor({offsetrow+12, offsetcol+1}, {YELLOW, BLACK}, "")

key = wait_key()

return key
end function

-----------------------------------------------------------------------------------------------------------------
global procedure keycard_make_appt()
-----------------------------------------------------------------------------------------------------------------
sequence dl, diary_list
integer sel, cur_sel

--get the diary list
dl = call_func(rid_gdl, {})
diary_list = {}
for i = 1 to length(dl) do
        diary_list = append(diary_list, dl[i][1])
end for

SetColors(BRIGHT_GREEN, BLACK)
SetSize(length(dl)+1, 30)
position((SCREEN_LINES-(length(dl)+2))/2, (SCREEN_COLS-30)/2)

cur_sel = 1
sel = ListBoxIndex("", diary_list, cur_sel)

SetSize(1,1)
position(1,1)
SetColors(WHITE, BLACK) SetStyle(5) MessageBox("",{}) SetStyle(1)
clear_screen()

if sel > 0 then
        called_from_patient = TRUE
        VOID = call_func(rid_open_diary, {diary_list[sel]})
        called_from_patient = FALSE
end if

SetSize(1,1)
position(1,1)
SetColors(WHITE, BLACK) SetStyle(5) MessageBox("",{}) SetStyle(1)
clear_screen()

end procedure

-----------------------------------------------------------------------------------------------------------------
global procedure keycard_list_notes()
-----------------------------------------------------------------------------------------------------------------
sequence result, from_date_str, to_date_str, fname
atom from_date_num, to_date_num, cur_date_num
integer fp


if match("archive", Notes[1][N_NOTE]) = 0  then
        from_date_str = Notes[1][N_DATE]
        to_date_str = Notes[$][N_DATE]
else
        from_date_str = "01/01/1980"
        to_date_str = Notes[$][N_DATE]
end if  
        
fname = sprintf("%d%d", {CurClient[CL_CLIENT_NO], CurPatient[PA_PATIENT_NO]})

SetSize(10,32)
result = MixedForm("List notes (ESC to finish)", {YELLOW, BLUE}, floor((SCREEN_LINES-10)/2), floor((SCREEN_COLS-32)/2),
                        {
                        {MF_CHECK, 3, 2, TRUE, "Show prices"},                          --1
                        {MF_CHECK, 4, 2, TRUE, "Include clinical notes"},               --2
                        {MF_CHECK, 5, 2, TRUE, "Show drugs notes"},                     --3
                        {MF_CHECK, 6, 2, TRUE, "Show services notes"},                  --4
                        {MF_CHECK, 7, 2, TRUE, "Show payments and invoices"},           --5
                        {MF_LABEL, 8, 2, "From date " },                                --6
                        {MF_LABEL, 9, 2, "To date   " },                                --7
                        {MF_TEXT,  8, 13, 10,from_date_str},                            --8
                        {MF_TEXT,  9, 13, 10,to_date_str}                               --9
                        }
                        )
                        
--clear the box
SetSize(10,32)
position((SCREEN_LINES-10)/2, (SCREEN_COLS-32)/2)
SetColors(WHITE, BLACK) SetStyle(5) MessageBox("",{}) SetStyle(1)

from_date_num = dateStrtoJdays(result[8])
to_date_num = dateStrtoJdays(result[9])


fp = open(fname, "w")

--create page header
printf(fp, "%s\n", {globalSettings[GS_PRACTICE]})
printf(fp, "%s\n", {globalSettings[GS_ADDRESS1]})
printf(fp, "%s\n", {globalSettings[GS_ADDRESS2]})
printf(fp, "%s\n", {globalSettings[GS_ADDRESS3]})
printf(fp, "%s\n", {globalSettings[GS_ADDRESS4]})
printf(fp, "%s\n", {globalSettings[GS_POSTCODE]})
printf(fp, "%s\n", {globalSettings[GS_TEL]})
printf(fp, "Branch : %s\n\n", {globalSettings[GS_BRANCH]})

printf(fp, "Client : %-30.30s    Patient : %s\n", {remove_trailing_spaces(CurClient[CL_TITLE]) & " " &  remove_trailing_spaces(CurClient[CL_FIRST_NAME]) & " " & remove_trailing_spaces(CurClient[CL_SURNAME]), CurPatient[PA_NAME]        })
printf(fp, "         %-30.30s              %s\n", {CurClient[CL_ADDRESS1],  CurPatient[PA_SPECIES]       })
printf(fp, "         %-30.30s              %s\n", {CurClient[CL_ADDRESS2],  CurPatient[PA_BREED]      })
printf(fp, "         %-30.30s              %s\n", {CurClient[CL_ADDRESS3],  CurPatient[PA_SEX]          })
printf(fp, "         %-30.30s              %s\n", {CurClient[CL_ADDRESS4],  CurPatient[PA_DOB]         })
printf(fp, "         %-30.30s              %.2f Kg\n", {CurClient[CL_POSTCODE], strtoval(CurPatient[PA_WEIGHT])         })
printf(fp, "         %-30.30s\n", {CurClient[CL_TEL1]})

puts(fp,"--------------------------------------------------------------------------------\n\n")

for i = 1 to length(Notes) do
        if dateStrtoJdays(Notes[i][N_DATE]) >= from_date_num and dateStrtoJdays(Notes[i][N_DATE]) <= to_date_num then
                if      (result[2] = TRUE and (Notes[i][N_TYPE][1] = 'T' or Notes[i][N_TYPE][1] = 'W' or Notes[i][N_TYPE][1] = ' ') ) or        
                        (result[3] = TRUE and Notes[i][N_TYPE][1] = 'D') or
                        (result[4] = TRUE and Notes[i][N_TYPE][1] = 'S') or
                        (result[5] = TRUE and Notes[i][N_TYPE][1] = 'P') or     
                        (result[5] = TRUE and Notes[i][N_TYPE][1] = 'A') then

                        if i = 1 then
                                printf(fp,"%s %-3.3s %-57.57s ", {remove_trailing_spaces(Notes[i][N_DATE]), Notes[i][N_USER], Notes[i][N_NOTE]})
                        elsif i > 1 and equal(Notes[i][N_DATE], Notes[i-1][N_DATE]) = 0 then
                                printf(fp,"%s %-3.3s %-57.57s ", {remove_trailing_spaces(Notes[i][N_DATE]), Notes[i][N_USER], Notes[i][N_NOTE]})
                        else
                                printf(fp,"%10.10s %-3.3s %-57.57s ", {"", Notes[i][N_USER], Notes[i][N_NOTE]})
                        end if

                        if result[1] = TRUE and strtoval(Notes[i][N_TOTAL]) != 0 then
                                printf(fp, "%6.2f\n", {strtoval(Notes[i][N_TOTAL])})
                        else
                                puts(fp, "\n")
                        end if
                end if  
        end if
end for

close(fp)

system_view_file(fname)

if upper(get_yn_box("Print this (y/n)[y]")) = 'Y' then
      --so print it!
        printers_print_file(fname, PR_HISTORY)
        SetSize(2,50) SetColors(YELLOW, GREEN)
        position(floor((SCREEN_LINES - 3)/2), floor((SCREEN_COLS - 50)/2))
        MessageBox("", {fname & " sent to " & printers[PR_HISTORY]})
        sleep(1)
        SetSize(2,50)
        position(floor((SCREEN_LINES - 3)/2), floor((SCREEN_COLS - 50)/2))
        SetColors(WHITE, BLACK) SetStyle(5) MessageBox("",{}) SetStyle(1)
        
end if

system_delete_file(fname)
                        
end procedure

-----------------------------------------------------------------------------------------------------------------
global procedure keycard_freehand_label()
-----------------------------------------------------------------------------------------------------------------
sequence result

position( floor((SCREEN_LINES - 5)/2), floor((SCREEN_COLS - 40)/2))
SetColors(BLACK, CYAN)

result = Form("Freehand label",
                {"Drug       ", "", 30,
                 "Directions ", "", 30,
                 "           ", "", 30,
                 "Quantity   ", "1", 5
                })


printers_freehand_drug_label(remove_trailing_spaces(result[1]), remove_trailing_spaces(result[2]), remove_trailing_spaces(result[3]), strtoval(result[4]))

end procedure

-----------------------------------------------------------------------------------------------------------------
global procedure keycard_patient_label()
-----------------------------------------------------------------------------------------------------------------
sequence result

SetSize(6, 22)
result = MixedForm("Client / patient label", {BRIGHT_WHITE, BLUE}, floor((SCREEN_LINES-5)/2), floor((SCREEN_COLS-22)/2),
                                        {
                                        {MF_CHECK, 3,2,TRUE, "Client details"},
                                        {MF_CHECK, 4,2,TRUE, "Patient details"},
                                        {MF_CHECK, 5,2,TRUE, "with telephone?"}
                                        }
                                        )
                                        
--clear the box
SetSize(6,22)
position((SCREEN_LINES-5)/2, (SCREEN_COLS-22)/2)
SetColors(WHITE, BLACK) SetStyle(5) MessageBox("",{}) SetStyle(1)
                                                                                
if result[1] = 1 or result[2] = 1 then
        if result[1] = 1 and result[2] = 1 then
                --client and patient
                printers_client_and_patient_label(result[3])
        end if
        
        if result[1] = 1 and result[2] = 0 then
                --client only
                printers_client_only_label(result[3])
        end if
        
        if result[1] = 0 and result[2] = 1 then
                --patient only
                printers_patient_only_label(result[3])
        end if
end if                                  
                                        
end procedure


-----------------------------------------------------------------------------------------------------------------
global function keycard_weight()
-----------------------------------------------------------------------------------------------------------------
sequence result, box

SetSize(4,30)

position((SCREEN_LINES-4)/2, (SCREEN_COLS-30)/2)
SetColors(BRIGHT_WHITE, BLUE)
box = PlainBox(DefaultBox)

printcolor({(SCREEN_LINES-4)/2 + 1, (SCREEN_COLS-30)/2 + 1}, {BRIGHT_WHITE, BLUE}, "Enter the current weight, or")
printcolor({(SCREEN_LINES-4)/2 + 2, (SCREEN_COLS-30)/2 + 1}, {BRIGHT_WHITE, BLUE}, "'A' to analyse the weights")
printcolor({(SCREEN_LINES-4)/2 + 3, (SCREEN_COLS-30)/2 + 10}, {BRIGHT_WHITE, BLACK}, "          ")
position( (SCREEN_LINES-4)/2 + 3, (SCREEN_COLS-30)/2 + 10)

result = get_max_str(10)

--clear the box
SetSize(4,30)
position((SCREEN_LINES-4)/2, (SCREEN_COLS-40)/2)
SetColors(WHITE, BLACK) SetStyle(5) MessageBox("",{}) SetStyle(1)

if length(result) = 0 then
        return "0"
end if

if upper(result[1]) = 'A' then
        --analyse weights on notes
        VOID = weight_analysis()
end if

if strtoval(result) > 0 then
        return sprintf("%.2f", {strtoval(result)})
else                                            
        return "0"
end if

return "0"
end function


-----------------------------------------------------------------------------------------------------------------
global procedure keycard_bill_today()
--bills range of dates - not just today
--must have a refreshed set of Notes for this
-----------------------------------------------------------------------------------------------------------------
sequence result, from_date_str, to_date_str, fname, cur_date_str
atom from_date_num, to_date_num, cur_date_num, total_payments, work_total
integer fp, j
sequence tNotes, temp

--from_date_str = Notes[1][N_DATE]
--to_date_str = Notes[$][N_DATE]
cur_date_str = DateToStr(nowDate())
total_payments = 0

tNotes = {}
temp = {}

fname = sprintf("%d%d-bill", {CurClient[CL_CLIENT_NO], CurPatient[PA_PATIENT_NO]})

cur_date_num = dateStrtoJdays(cur_date_str)

position( floor((SCREEN_LINES - 5)/2), floor((SCREEN_COLS - 30)/2))
SetColors(BLACK, CYAN)

result = Form("Bill - enter dates",
                {"From date ", cur_date_str, 15,
                 "To date   ", cur_date_str, 15
                }
                )
                
from_date_str = result[1]
to_date_str = result[2]
from_date_num = dateStrtoJdays(from_date_str)
to_date_num = dateStrtoJdays(to_date_str)


fp = open(fname, "w" )

--header of bill
printf(fp, "%s\n", {globalSettings[GS_PRACTICE]})
printf(fp, "%s\n", {globalSettings[GS_ADDRESS1]})
printf(fp, "%s\n", {globalSettings[GS_ADDRESS2]})
printf(fp, "%s\n", {globalSettings[GS_ADDRESS3]})
printf(fp, "%s\n", {globalSettings[GS_ADDRESS4]})
printf(fp, "%s\n", {globalSettings[GS_POSTCODE]})
printf(fp, "%s\n", {globalSettings[GS_TEL]})
printf(fp, "Branch : %s\n\n", {globalSettings[GS_BRANCH]})

printf(fp, "------------------------------------------------\n\n", {} )

printf(fp, "%s %s\n", {CurClient[CL_TITLE], remove_trailing_spaces(CurClient[CL_SURNAME])})
printf(fp, "%s\n", {CurClient[CL_ADDRESS1]})

printf(fp, "%s\n===============\n\n", {remove_trailing_spaces(CurPatient[PA_NAME])})

work_total = 0

--main body
--first create temporary notes list for date range
for i = 1 to length(Notes) do
        cur_date_num = dateStrtoJdays(Notes[i][N_DATE])
        if (cur_date_num >= from_date_num and cur_date_num <= to_date_num) and strtoval(Notes[i][N_TOTAL]) > 0 then
                --exclude payments from bill, but add up for total at end
                if Notes[i][N_TYPE][1] != 'P' then
                        temp = Notes[i] 
                        tNotes =  append(tNotes, temp)
                        work_total += strtoval(Notes[i][N_TOTAL])
                else
                        total_payments += strtoval(Notes[i][N_TOTAL])
                end if
        end if
end for

for i = 1 to length(tNotes) do
        if i = 1 then
                printf(fp,"%s \n%-38.38s %8.2f\n", {remove_trailing_spaces(tNotes[i][N_DATE]), tNotes[i][N_NOTE], strtoval(tNotes[i][N_TOTAL])})
        elsif i > 1 and equal(tNotes[i][N_DATE], tNotes[i-1][N_DATE]) = 0 then
                --how wide is the printer - can't remember
                printf(fp,"\n%s \n%-38.38s %8.2f\n", {remove_trailing_spaces(tNotes[i][N_DATE]), tNotes[i][N_NOTE], strtoval(tNotes[i][N_TOTAL])})
        else
                printf(fp,"%-38.38s %8.2f\n", {tNotes[i][N_NOTE], strtoval(tNotes[i][N_TOTAL])})
        end if
end for

printf(fp,"\n%-38.38s %8.2f\n", {"Total", work_total})

printf(fp, "\n------------------------------------------------\n\n", {} )

printf(fp, "Payments made     : %8.2f\n", {total_payments})
printf(fp, "Patient balance   : %8.2f\n", {strtoval(CurPatient[PA_OUTS_BAL])} ) 
printf(fp, "Total Outstanding : %8.2f\n", {strtoval(CurClient[CL_OUTS_BAL])} ) 

-- footer of bill (xmas greeting, special offers, vouchers)

--form feed
puts(fp, "\n\n\n\n\n\n\n")

close(fp)

--print it and delete the file          
printers_print_file(fname, PR_RECEIPT)
unlink(fname)

end procedure

-----------------------------------------------------------------------------------------------------------------
global procedure keycard_change_user()
-----------------------------------------------------------------------------------------------------------------
sequence password, data, cmd
integer c
password = ""

SetColors(WHITE, RED)
--postion(line, column)
position(  (SCREEN_LINES/2) - 3, (SCREEN_COLS/2) - 12)
SetSize(2, 25)
MessageBox("Enter your login password", {})

while 1 do
    c = wait_key()
    if c = ENTER then exit end if
    password = password & c
end while
password = remove_trailing_spaces(password)

cmd = "SELECT * from Pus WHERE p = '" & password & "'"
data = query_database("xprods.sql", cmd)

if length(data) = 0 then
        VOID = get_yn_box("Password not found - user unchanged")
else
        CurUser[U_NAME] = data[2][U_NAME]
        CurUser[U_INIT] = data[2][U_INIT]
        CurUser[U_PASS] = data[2][U_PASS]
        CurUser[U_SECURITY] = data[2][U_SECURITY]
end if


end procedure


-----------------------------------------------------------------------------------------------------------------
global procedure keycard_archived_notes()
-----------------------------------------------------------------------------------------------------------------
sequence cmd, data
integer fp

cmd = sprintf("SELECT * FROM Notes WHERE patient_no = %d", {CurPatient[PA_PATIENT_NO]})
data = query_database("xarchive.sql", cmd)

fp = open(sprintf("%d%d.tmp", {CurClient[CL_CLIENT_NO], CurPatient[PA_PATIENT_NO]}), "w")
for i = 2 to length(data) do
        printf(fp, "%s %s\n", {data[i][N_DATE], data[i][N_NOTE]})
end for 
close(fp)

system_view_file(sprintf("%d%d.tmp", {CurClient[CL_CLIENT_NO], CurPatient[PA_PATIENT_NO]}) )
unlink(sprintf("%d%d.tmp", {CurClient[CL_CLIENT_NO], CurPatient[PA_PATIENT_NO]}))

end procedure


-----------------------------------------------------------------------------------------------------------------
global function keycard_search_notes()
-----------------------------------------------------------------------------------------------------------------
sequence cmd, data, result, box, fname, notes_result
integer fp, pa

position(10,10)
SetColors(BLACK, GREEN)
SetSize(4, 25)

result = Input("Enter Search string", {""}, "                       ")
result = remove_trailing_spaces(result)

notes_result = {}

--old_notes
cmd = sprintf("SELECT * FROM Notes WHERE patient_no = %d", {CurPatient[PA_PATIENT_NO]}) &
                "AND Note LIKE '%" & result & "%'"
data = query_database("xarchive.sql", cmd)

if length(data) > 0 then
        notes_result = data[2..$]
end if       

--current notes
cmd = sprintf("SELECT * FROM Notes WHERE patient_no = %d ", {CurPatient[PA_PATIENT_NO]}) &
                "AND Note LIKE '%" & result & "%'"
data = query_database("xnotes.sql", cmd)

if length(data) > 0 then
        for i = 2 to length(data) do
                notes_result = append(notes_result, data[i])
        end for
end if

if length(notes_result) = 0 then
        VOID = get_yn_box("No matches found")
        return 0
end if

--display results in file
fname = sprintf("%d%d.srch", {CurClient[CL_CLIENT_NO], CurPatient[PA_PATIENT_NO]})

fp = open(fname, "w")
for i = 1 to length(notes_result) do
        printf(fp, "%s %s\n", {notes_result[i][N_DATE], notes_result[i][N_NOTE]})       
end for
close(fp)

system_view_file(fname)

pa = upper(get_yn_box("Print this (L - label, Y - as report)") )
if pa = 'Y' or pa = 'R' then
        printers_print_file(fname, PR_GENERAL)
end if

if pa = 'L' then
        --print as label
        printers_notes_search_label(notes_result)
end if

unlink(fname)

return 0
end function

-----------------------------------------------------------------------------------------------------------------
global function keycard_rescind_deceased()
--returns a patient from the dead
-----------------------------------------------------------------------------------------------------------------
integer mm
sequence tmp

if sequence(CurPatient[PA_STATUS]) = 0 then
        return 0
end if

if CurPatient[PA_STATUS][ST_DEAD] = 'X' then
        CurPatient[PA_STATUS][ST_DEAD] = '-'
        
        while 1  do
                mm =  match("(D)", CurPatient[PA_NAME])
                if mm > 0 then
                        tmp = {}
                        for i = 1 to length(CurPatient[PA_NAME]) do     
                                if i < mm then
                                        tmp = append(tmp, CurPatient[PA_NAME][i]) 
                                elsif i > mm + 2 then
                                        tmp = append(tmp, CurPatient[PA_NAME][i]) 
                                end if 
                        end for         
                else
                        exit                
                end if
                CurPatient[PA_NAME] = tmp
        end while

        data_update_patient()        
end if

VOID = get_yn_box("Dead status rescinded")

return 0
end function
