--Services and drugs

------------------------------------------------------------------------------------
function assign_categories()
------------------------------------------------------------------------------------
integer offsetrow, offsetcol, c , fp
sequence box, pc


--have categories in ProductCategories

box = DefaultBox
offsetrow = 5
offsetcol = 3
pc = {}

--create and display a generic box with the listed categories
position(offsetrow, offsetcol)
SetSize(17, 70)
SetColors(BRIGHT_BLUE, BLACK)
box = GenericBox("Categories - select letter, modify as required, ESC to finish", "")

for i = 1 to 13 do
        printcolor({offsetrow + 3 + i, offsetcol + 1}, {BRIGHT_BLUE, BLACK}, sprintf("%s %s", {'A'-1+i, ProductCategories[i]}))
end for
for i = 14 to 26 do
        printcolor({offsetrow + 3 + i - 13, offsetcol + 35}, {BRIGHT_BLUE, BLACK}, sprintf("%s %s", {'A'-1+i, ProductCategories[i]}))
end for

flush_key_buffers()

while 1 do
        c = upper(wait_key())
        
        if c = ESC then exit end if
        
        if c >= 'A' and c <= 'Z' then
                position(offsetrow+5, offsetcol+5)
                SetColors(BLUE, WHITE)
                pc = Form("Enter the new category for " & c,
                                {"","", 25
                                })
                
                ProductCategories[c-'A' + 1 ] = pc[1]
                
                position(offsetrow, offsetcol)
                SetSize(17, 70)
                SetColors(BRIGHT_BLUE, BLACK)
                box = GenericBox("Categories - select letter, modify as required, ESC to finish", "")
                
                for i = 1 to 13 do
                        printcolor({offsetrow + 3 + i, offsetcol + 1}, {BRIGHT_BLUE, BLACK}, sprintf("%s %s", {'A'-1+i, ProductCategories[i]}))
                end for
                for i = 14 to 26 do
                        printcolor({offsetrow + 3 + i - 13, offsetcol + 35}, {BRIGHT_BLUE, BLACK}, sprintf("%s %s", {'A'-1+i, ProductCategories[i]}))
                end for
        end if


end while

--write out the xprod_cats file
fp = open("xprod_cats", "w")
for i = 1 to length(ProductCategories) do
        ProductCategories[i] = remove_trailing_spaces(ProductCategories[i])
        printf(fp, "%s\n", {ProductCategories[i]} )
end for 
close(fp)


--clear the box
SetSize(17,70) position(offsetrow, offsetcol) SetColors(WHITE, BLACK) SetStyle(5) MessageBox("",{}) SetStyle(1)



return 0
end function



------------------------------------------------------------------------------------
function price_list()
------------------------------------------------------------------------------------
sequence chosen, item_list, ch_list, cmd, data, tmp
integer fp, category_counter
atom price
object c

chosen = {}
item_list = {"Drugs", "Services", "Vat Inclusive", "Sorted by category"}
ch_list = {0,0,0,0}
price = 0

--create a selection box for requirements
position(8,8)
SetSize(7,38)
SetColors(BLACK, CYAN)
chosen = CheckBox("Select requirements for the printout", item_list)

if length(chosen) > 0 then
        --get chosen items
        for i = 1 to 4 do
                for j = 1 to length(chosen) do
                if compare(item_list[i], chosen[j]) = 0 then
                        ch_list[i] = 1
                end if
                end for
        end for
        
        --create the cmd
        cmd = "SELECT item, category, sales_price, markup, vat, type FROM Products ORDER BY item"
        
        if ch_list[1] = 0 and ch_list[2] = 0 then
                VOID = get_yn_box("You have selected neither drogs or services!")
                --clear the box
                SetSize(7,38) position(8,8) SetColors(WHITE, BLACK) SetStyle(5) MessageBox("",{}) SetStyle(1)
                return 0
        end if
        
        data = query_database("xprods.sql", cmd)
        
        if length(data) < 1 then
                VOID = get_yn_box("No data returned from search")
                SetSize(7,38) position(8,8) SetColors(WHITE, BLACK) SetStyle(5) MessageBox("",{}) SetStyle(1)
                return 0
        end if
        
        --create file title
        fp = open("Price_list.txt", "w")
        puts(fp, "Price list " & DateToStr(nowDate()) & "\n")
        puts(fp, "=========================\n\n")
        if ch_list[3] = 1 then
                puts(fp, "VAT Inclusive\n\n")
        else
                puts(fp, "VAT exclusive\n\n")
        end if

        --not categorised       
        if ch_list[4] = 0 then  
        
                if ch_list[1] = 1 then
                        puts(fp, "Drugs\n-----\n\n")
                        printf(fp, "%-40s %-10s\n", {"Item", "Price"})
                        printf(fp, "%-40s %-10s\n", {"----", "-----"})
                
                        for i = 2 to length(data) do
                                if data[i][6][1] = 'D' then
                                        if ch_list[3] = 1 then
                                                price = strtoval(data[i][3]) * (1 + strtoval(data[i][4])/100) * (1 + strtoval(data[i][5])/100)
                                        else
                                                price = strtoval(data[i][3]) * (1 + strtoval(data[i][4])/100)
                                        end if
                                        printf(fp, "%-40s %10.2f\n", {data[i][1], price})
                                end if
                        end for
                        puts(fp, "\n\n")
                end if --end of ch_list[1]
                
                if ch_list[2] = 1 then
                        puts(fp, "Services\n--------\n\n")
                        printf(fp, "%-40s %-10s\n", {"Item", "Price"})
                        printf(fp, "%-40s %-10s\n", {"----", "-----"})
                
                        for i = 2 to length(data) do
                                if data[i][6][1] = 'S' then
                                        if ch_list[3] = 1 then
                                                price = strtoval(data[i][3]) * (1 + strtoval(data[i][4])/100) * (1 + strtoval(data[i][5])/100)
                                        else
                                                price = strtoval(data[i][3]) * (1 + strtoval(data[i][4])/100)
                                        end if
                                        printf(fp, "%-40s %10.2f\n", {data[i][1], price})
                                end if
                        end for
                end if --end of ch_list[2]
                
                
        end if --end of not categorised
        
        --output by category
        if ch_list[4] = 1 then
                for i = 1 to 26 do
                        --create the category subtitle
                        puts(fp, "\nCategory - " & ProductCategories[i] & "\n-------------------------------------\n")

                        for j = 2 to length(data) do
                                if data[j][2][1] = i + 'A' - 1 then
                                        if (data[j][6][1] = 'S' and ch_list[2] = 1) or (data[j][6][1] = 'D' and ch_list[1] = 1) then
                                                if ch_list[3] = 1 then
                                                        price = strtoval(data[j][3]) * (1 + strtoval(data[j][4])/100) * (1 + strtoval(data[j][5])/100)
                                                else
                                                        price = strtoval(data[j][3]) * (1 + strtoval(data[j][4])/100)
                                                end if
                                                printf(fp, "%-40s %10.2f\n", {data[j][1], price})
                                        end if
                                end if
                        end for
                end for
        end if

        close(fp)
        system_view_file("Price_list.txt")

        --print the file
        c = upper(get_yn_box("Print the price list (y/n) [n]"))
        if c = 'Y' then
                printers_print_file("Price_list.txt", PR_GENERAL)
        end if
        system_delete_file("Price_list.txt")

end if

--clear the box
SetSize(7,38) position(8,8) SetColors(WHITE, BLACK) SetStyle(5) MessageBox("",{}) SetStyle(1)

return 0
end function



------------------------------------------------------------------------------------
procedure delete_item(sequence selected_item)
------------------------------------------------------------------------------------
sequence cmd, data

cmd = "DELETE FROM Products WHERE number = " & sprintf("%d", {selected_item[PROD_NUMBER]})

if upper(get_yn_box("Delete " & selected_item[PROD_ITEM] & " from database? (y/n)[n]")) = 'Y' then
    data = query_database("xprods.sql", cmd)
end if

end procedure



------------------------------------------------------------------------------------
function add_item_drug()
------------------------------------------------------------------------------------
sequence new_item, fi, fi2

new_item = repeat({}, 37)

position(8,8)
SetColors(BRIGHT_WHITE, GREEN)
fi = Form("Create new drug item (Page 1 of 2)",
                {"Drug name                ", "", 40,                   -- 1
                 "Purchase price           ", "", 10,   --pack cost     -- 2
                 "Quantity units in pack   ", "", 10,                   -- 3
                 "Pack units (tablets etc) ", "", 20,                   -- 4
                 "Selling quantity         ", "", 10,   --unit sales    -- 5
                 "Markup (%)               ", "", 10,                   -- 6
                 "Base fee                 ", "", 10,                   -- 7
                 "VAT (%)                  ", sprintf("%.2f", {globalSettings[GS_VAT]}), 10,                   -- 8
                 "Generate label (y/n)     ", "", 4,                    -- 9
                 "Label dosage             ", "", 40,                   -- 10
                 "Label warning            ", "", 40                    -- 11
                })

if length(fi[1]) = 0 then return new_item end if
if length(fi[2]) = 0 then fi[2] = "1" end if
if length(fi[3]) = 0 then fi[3] = "1" end if
if length(fi[4]) = 0 then fi[4] = "-" end if
if length(fi[5]) = 0 then fi[5] = "1" end if
if length(fi[6]) = 0 then fi[6] = "1" end if
if length(fi[7]) = 0 then fi[7] = "0" end if
if length(fi[9]) = 0 then fi[9] = "N" end if
if length(fi[10]) = 0 then fi[10] = "-" end if
if length(fi[11]) = 0 then fi[11] = "-" end if


position(8,8)
SetColors(BRIGHT_WHITE, GREEN)
fi2 = Form("Create new drug item (Page 2 of 2) " & fi[1],
                {"Category                 ", "", 10,                   -- 1
                 "Supplier                 ", "", 40,                   -- 2
                 "Supplier ref             ", "", 40,                   -- 3
                 "Manufacturer ref         ", "", 40,                   -- 4
                 "Product license          ", "", 40,                   -- 5
                 "Milk withhold (days)     ", "0", 4,                   -- 6
                 "Meat withhold (days)     ", "0", 4,                   -- 7
                 "Egg withhold (days)      ", "0", 4,                   -- 8
         "Initial stock level      ", "0", 6                    -- 9
                 
                })

if length(fi2[1]) = 0 then fi2[1] = "-" end if
if length(fi2[2]) = 0 then fi2[2] = "-" end if
if length(fi2[3]) = 0 then fi2[3] = "-" end if
if length(fi2[4]) = 0 then fi2[4] = "-" end if
if length(fi2[5]) = 0 then fi2[5] = "-" end if


new_item[PROD_ITEM] =               fi[1]
new_item[PROD_CODE] =               "-"
new_item[PROD_TYPE] =               "D"
new_item[PROD_CATEGORY] =           fi2[1]
new_item[PROD_SUPPLIER] =           fi2[2]
new_item[PROD_SUP_REF] =            fi2[3]
new_item[PROD_MAN_REF] =            fi2[4]
new_item[PROD_LICENSE] =            fi2[5]
--new_item[PROD_NUMBER] = 
new_item[PROD_PACK_COST] =          strtoval(fi[2])
new_item[PROD_UNITS_PACK] =         strtoval(fi[3])
new_item[PROD_PACK_UNITS] =         fi[4]
new_item[PROD_ANALYSIS] =           "-"
new_item[PROD_IN_STOCK] =           fi2[9]
new_item[PROD_UNIT_SALES] =         strtoval(fi[5])
new_item[PROD_COST] =               0
new_item[PROD_MARKUP] =             strtoval(fi[6])
new_item[PROD_DISC] =               0
new_item[PROD_SALES_PRICE] =        0 --calculated
new_item[PROD_MILK_WITHHOLD] =      strtoval(fi2[6])
new_item[PROD_MEAT_WITHHOLD] =      strtoval(fi2[7])
new_item[PROD_EGG_WITHHOLD] =       strtoval(fi2[8])
new_item[PROD_WARNING] =            fi[11]
new_item[PROD_GEN_LABEL] =          upper(fi[9])
new_item[PROD_EXTRA_LABEL] =        "-"
new_item[PROD_DOSAGE] =             fi[10]
new_item[PROD_GEN_LETTER] =         "-" 
new_item[PROD_VAT] =                strtoval(fi[8])
new_item[PROD_RECALL] =             0
new_item[PROD_DOSE_UNITS] =         "-"
new_item[PROD_WEIGHT_MULT] =        0
new_item[PROD_STATUS] =             "                    "
new_item[PROD_SEX] =                "-"
new_item[PROD_BASE_FEE] =           strtoval(fi[7])
new_item[PROD_INFO] =               "-"
new_item[PROD_RECALL_INTERVAL] =    0
new_item[PROD_RECALL_COUNT] =       0

--check for non zero division
if new_item[PROD_UNITS_PACK] > 0 then
    new_item[PROD_SALES_PRICE] = (new_item[PROD_PACK_COST] / new_item[PROD_UNITS_PACK]) * (1 + new_item[PROD_MARKUP]/100)
else
    VOID = get_yn_box("Warning - quantity in pack set to 1 - edit as required")
    new_item[PROD_UNITS_PACK] = 1
    new_item[PROD_SALES_PRICE] = (new_item[PROD_PACK_COST] / new_item[PROD_UNITS_PACK]) * (1 + new_item[PROD_MARKUP]/100)
end if

return new_item
end function

------------------------------------------------------------------------------------
function add_item_service()
------------------------------------------------------------------------------------
sequence new_item, fi

new_item = repeat({}, 37)

position(8,8)
SetColors(BRIGHT_WHITE, GREEN)

fi = Form("Create new service item",
                {"Service name       ", "", 30,
                 "Fee                ", "", 10,
                 "Base price         ", "", 10,
                 "VAT                ", sprintf("%.2f", {globalSettings[GS_VAT]}), 10,
                 "Sex                ", "", 4,
                 "Reminder slot      ", "", 4,
                 "Reminder interval  ", "", 4,
                 "Reminder repeats   ", "", 4,
                 "Change to deceased ", "",4                
                }
                )

new_item[PROD_ITEM] = fi[1]
new_item[PROD_CODE] = "-"
new_item[PROD_TYPE] = "S"
new_item[PROD_CATEGORY] = "-" 
new_item[PROD_SUPPLIER] = "-"
new_item[PROD_SUP_REF] = "-"
new_item[PROD_MAN_REF] = "-"
new_item[PROD_LICENSE] = "-"
--new_item[PROD_NUMBER] = 
new_item[PROD_PACK_COST] = 0
new_item[PROD_UNITS_PACK] = 1
new_item[PROD_PACK_UNITS] = "-"
new_item[PROD_ANALYSIS] = "-"
new_item[PROD_IN_STOCK] = 0
new_item[PROD_UNIT_SALES] = 0
new_item[PROD_COST] = 0
new_item[PROD_MARKUP] = 0 
new_item[PROD_DISC] = 0
new_item[PROD_SALES_PRICE] = strtoval(fi[2])
new_item[PROD_MILK_WITHHOLD] = 0
new_item[PROD_MEAT_WITHHOLD] = 0
new_item[PROD_EGG_WITHHOLD] = 0
new_item[PROD_WARNING] = "-"
new_item[PROD_GEN_LABEL] = "-"
new_item[PROD_EXTRA_LABEL] = "-"
new_item[PROD_DOSAGE] = "-"
new_item[PROD_GEN_LETTER] = "-" 
new_item[PROD_VAT] = strtoval(fi[4])
new_item[PROD_RECALL] = strtoval(fi[6])
new_item[PROD_DOSE_UNITS] = "-"
new_item[PROD_WEIGHT_MULT] = 0
new_item[PROD_STATUS] = "                    "
new_item[PROD_SEX] = fi[5]
new_item[PROD_BASE_FEE] = strtoval(fi[3])
new_item[PROD_INFO] = "-"
new_item[PROD_RECALL_INTERVAL] = strtoval(fi[7])
new_item[PROD_RECALL_COUNT] = strtoval(fi[8])

--make dead?
if length(fi[9]) > 0 and fi[9][1] = 'Y' then
        new_item[PROD_STATUS][1] = 'X'
end if


return new_item
end function

------------------------------------------------------------------------------------
procedure add_item()
------------------------------------------------------------------------------------
sequence item_type, new_item


new_item = repeat({}, 37)

--service or drug?
SetSize(5, 30)
position(8,8)
SetColors(BRIGHT_GREEN, BLACK)
item_type = RadioBox_def("What sort of item do you want?",
                        {"Service", "Drug"}, 1)

--head off to the appropriate section
if item_type[1][1] = 'S' then
        new_item = add_item_service()
else
        new_item = add_item_drug()
end if

--save it?
if upper(get_yn_box(" Save new " & item_type[1] & "? (y/n)[n] ")) = 'Y' then
    new_item = data_validate_product(new_item)
        data_insert_product(new_item)
end if

end procedure



------------------------------------------------------------------------------------
function drug_options_type(sequence selected_item)
------------------------------------------------------------------------------------
sequence item_type

item_type = RadioBox_def("Set the type for the item.",
                        {"Service", "Drug"}, 2)

selected_item[PROD_TYPE] = item_type[1]                                         

return selected_item
end function

------------------------------------------------------------------------------------
function service_options_type(sequence selected_item)
------------------------------------------------------------------------------------
sequence item_type

item_type = RadioBox_def("Set the type for the item.",
                        {"Service", "Drug"}, 1)

selected_item[PROD_TYPE] = item_type[1]                                         

return selected_item
end function


------------------------------------------------------------------------------------
function service_options_details(sequence selected_item)
------------------------------------------------------------------------------------
sequence service_details, make_dead

--deceased selection
if length(selected_item[PROD_STATUS]) < 2 then
        selected_item[PROD_STATUS] = "-     "
end if

if selected_item[PROD_STATUS][1] = 'X' then
        make_dead = "Y"
else
        make_dead = "N"
end if

--vaccination selection for product
selected_item = data_validate_product(selected_item)


--create the service details sequence
service_details = {selected_item[PROD_ITEM],
                   selected_item[PROD_SALES_PRICE],
                   selected_item[PROD_BASE_FEE],
                   selected_item[PROD_VAT],
                   selected_item[PROD_WEIGHT_MULT],
                   selected_item[PROD_SEX],             --dictates if changes sex of patient
                   selected_item[PROD_RECALL],          --the recall slot
                   selected_item[PROD_RECALL_INTERVAL],
                   selected_item[PROD_RECALL_COUNT],
                   make_dead
                   }

--the form
position(6,2)        
service_details = Form("Edit details for " & selected_item[PROD_ITEM],
                        {"Description                 ", selected_item[PROD_ITEM], 40,
                         "Fee (use # for VAT inc)     ", sprintf("%.2f", {selected_item[PROD_SALES_PRICE]}), 10,
                         "Base fee                    ", sprintf("%.2f", {selected_item[PROD_BASE_FEE]}), 10,
                         "VAT                         ", sprintf("%.2f", {selected_item[PROD_VAT]}), 10,
                         "Weight multiplier           ", sprintf("%.2f", {selected_item[PROD_WEIGHT_MULT]}), 10,
                         "Sex change                  ", selected_item[PROD_SEX], 4,
                         "Reminder slot to use        ", sprintf("%d", {selected_item[PROD_RECALL]}), 4,
                         "Reminder interval           ", sprintf("%d", {selected_item[PROD_RECALL_INTERVAL]}), 4,
                         "Number of overdue reminders ", sprintf("%d", {selected_item[PROD_RECALL_COUNT]}), 4,
                         "Deceased (Yes / No)         ", make_dead, 4                   
                        })              
                                   
--deadness
if upper(service_details[10][1]) = 'Y' then
    selected_item[PROD_STATUS][1] = 'X' 
else
    selected_item[PROD_STATUS][1] = ' ' 
end if

--calculate real amt if first char is #
if service_details[2][1] = '#' and length(service_details[2]) > 2 then
    service_details[2] = service_details[2][2..$]
    service_details[2] = strtoval(service_details[2])

    selected_item[PROD_VAT] = strtoval(service_details[4])

    service_details[2] = service_details[2] / (1+ (selected_item[PROD_VAT]/100) )
end if


--put values back into selected_item
selected_item[PROD_ITEM] = service_details[1]
selected_item[PROD_SALES_PRICE] = service_details[2]
selected_item[PROD_BASE_FEE] = service_details[3]
selected_item[PROD_VAT] = service_details[4]
selected_item[PROD_WEIGHT_MULT] = service_details[5]
selected_item[PROD_SEX] = service_details[6]
selected_item[PROD_RECALL]      = service_details[7]
selected_item[PROD_RECALL_INTERVAL]     = service_details[8]
selected_item[PROD_RECALL_COUNT]        = service_details[9]

selected_item = data_validate_product(selected_item)


return selected_item
end function



------------------------------------------------------------------------------------
function service_options_menu(sequence selected_item)
------------------------------------------------------------------------------------
integer choice, current_choice
sequence menu_opts

menu_opts = {"Details",  "Type", "Delete from database", "Vaccination slots", "Quit"}

current_choice = 1
while 1 do
        SetSize(10, 40)
        position(8,8)
        SetColors(BRIGHT_WHITE, BLUE)
        choice = Select(selected_item[PROD_ITEM], current_choice, menu_opts)

        current_choice = choice
        
        if choice = -1 or choice = length(menu_opts) then exit end if
        
        if choice = 1 then
                selected_item = service_options_details(selected_item)  
        
        elsif choice = 2 then
                selected_item = service_options_type(selected_item)
                if selected_item[PROD_TYPE][1] = 'D' then --the type has changed
                        exit
                end if
    
    elsif choice = 3 then
        delete_item(selected_item)
        selected_item = {}
        exit

    elsif choice = 4 then
            global_remindertypes()
    end if
        
end while

--tidy the sreen
position(4,1) SetSize(SCREEN_LINES-4,SCREEN_COLS) SetColors(WHITE, BLACK) SetStyle(5) MessageBox("", {}) SetStyle(1)


return selected_item
end function


------------------------------------------------------------------------------------
function drug_options_name(sequence selected_item)
------------------------------------------------------------------------------------
sequence name_details

--create a form with details

name_details = {selected_item[PROD_ITEM],
                selected_item[PROD_CATEGORY],
                selected_item[PROD_CODE],
                selected_item[PROD_ANALYSIS],
                selected_item[PROD_SUPPLIER],
                selected_item[PROD_SUP_REF],
                selected_item[PROD_MAN_REF],
                selected_item[PROD_LICENSE],
                selected_item[PROD_BATCH_NUMBER]
                }

position(6,2)        
name_details = Form("Edit details - " & name_details[1],
                        {"Description    ", name_details[1], 40,
                         "Category       ", name_details[2], 10,
                         "Code           ", name_details[3], 10,
                         "Analysis       ", name_details[4], 10,
                         "Supplier       ", name_details[5], 40,
                         "Supplier ref   ", name_details[6], 20,
                         "Manufactur ref ", name_details[7], 20,
                         "License        ", name_details[8], 20,
                         "Cur batch num  ", name_details[9], 20
                         })             

for i = 1 to length(name_details) do
        name_details[i] = remove_trailing_spaces(name_details[i])
end for                  
                         
selected_item[PROD_ITEM] = name_details[1]
selected_item[PROD_CATEGORY] = name_details[2]
selected_item[PROD_CODE] = name_details[3]
selected_item[PROD_ANALYSIS] = name_details[4]
selected_item[PROD_SUPPLIER] = name_details[5]
selected_item[PROD_SUP_REF] = name_details[6]
selected_item[PROD_MAN_REF] = name_details[7]
selected_item[PROD_LICENSE] = name_details[8]                    
selected_item[PROD_BATCH_NUMBER] = name_details[9]
                         
return selected_item
end function

------------------------------------------------------------------------------------
function drug_options_sale(sequence selected_item)
------------------------------------------------------------------------------------
sequence sale_details, sdt, example

example = {}

sale_details = {selected_item[PROD_PACK_COST],
                        selected_item[PROD_UNITS_PACK],
                        selected_item[PROD_PACK_UNITS],
                        selected_item[PROD_UNIT_SALES],
                        selected_item[PROD_MARKUP],
                        selected_item[PROD_BASE_FEE],
                        selected_item[PROD_COST],
                        selected_item[PROD_VAT],
                        selected_item[PROD_SALES_PRICE] --not sure if this one needed here
                        }

position(6,2)        
sdt = Form("Edit details - " & selected_item[PROD_ITEM],
        {"Practice purchase price                 ",  sprintf("%.2f", {sale_details[1]}), 10,
         "Number of units in pack                 ",  sprintf("%.2f", {sale_details[2]}), 10, 
         "Units (eg tablets, capsules)            ",  sale_details[3], 15,
         "Unit sales - ie sell how many at a time ",  sprintf("%.2f", {sale_details[4]}), 10,
         "Markup (%)                              ",  sprintf("%.2f", {sale_details[5]}), 10,
         "Base fee / dispensing fee               ",  sprintf("%.2f", {sale_details[6]}), 10,
         "VAT                                     ",  sprintf("%.2f", {sale_details[8]}), 10
        })

selected_item[PROD_PACK_COST] = sdt[1]
selected_item[PROD_UNITS_PACK] = sdt[2]
selected_item[PROD_PACK_UNITS] = sdt[3]
selected_item[PROD_UNIT_SALES] = sdt[4]
selected_item[PROD_MARKUP] = sdt[5]
selected_item[PROD_BASE_FEE] = sdt[6]
--selected_item[PROD_COST] = sale_details[7]         --cost per unit, with markup, exc base fee, exc VAT
selected_item[PROD_VAT] = sdt[7]
--selected_item[PROD_SALES_PRICE] = sale_details[9]

--have strings, comvert to numbers
selected_item = data_validate_product(selected_item)

--PROD_SALES_PRICE - what is used to calc cost to client
selected_item[PROD_SALES_PRICE] = (selected_item[PROD_PACK_COST] / selected_item[PROD_UNITS_PACK]) * (1 + selected_item[PROD_MARKUP]/100)

--show an example
example = append(example, "Per tablet (inc VAT, exc dispensing fee)")
example = append(example,
            sprintf("  %8.2f", {selected_item[PROD_SALES_PRICE] * (1 + selected_item[PROD_VAT]/100)    } ) )
example = append(example, "10 tablets (inc VAT, inc dispensing fee)")
example = append(example,
            sprintf("  %8.2f", { (selected_item[PROD_SALES_PRICE] * (1 + selected_item[PROD_VAT]/100) * 10) + (selected_item[PROD_BASE_FEE] * (1 + selected_item[PROD_VAT]/100)    ) } ) )

SetSize(8,40)
MessageBox(remove_trailing_spaces(selected_item[PROD_ITEM]) & " example" , example)
flush_key_buffers()
VOID = wait_key()
SetSize(8,40) SetColors(WHITE, BLACK) SetStyle(5) MessageBox("", {}) SetStyle(1)
                    

return selected_item
end function

------------------------------------------------------------------------------------
function drug_options_label(sequence selected_item)
------------------------------------------------------------------------------------
sequence label_details

label_details = {selected_item[PROD_GEN_LABEL],
                 selected_item[PROD_DOSAGE],
                 selected_item[PROD_WARNING],
                 selected_item[PROD_MILK_WITHHOLD],
                 selected_item[PROD_MEAT_WITHHOLD],
                 selected_item[PROD_EGG_WITHHOLD]
                 }

position(6,2)        
label_details = Form("Edit details - " & selected_item[PROD_ITEM],
                        {"Generate label       ", label_details[1], 4,
                         "Dosage               ", label_details[2], 40,
                         "Warning              ", label_details[3], 40,
                         "Withhold milk (days) ", label_details[4], 4,
                         "Withhold meat (days) ", label_details[5], 4,
                         "Withhold eggs (days) ", label_details[6], 4
                        })               

if length(label_details[1]) = 0 then label_details[1] = "N"  end if       

selected_item[PROD_GEN_LABEL] = upper(label_details[1])
selected_item[PROD_DOSAGE] = label_details[2]
selected_item[PROD_WARNING] = label_details[3]
selected_item[PROD_MILK_WITHHOLD] = label_details[4]
selected_item[PROD_MEAT_WITHHOLD] = label_details[5]
selected_item[PROD_EGG_WITHHOLD] = label_details[6]
                        
                                                
return selected_item
end function


------------------------------------------------------------------------------------
function drug_options_menu(sequence selected_item)
------------------------------------------------------------------------------------
integer choice, current_choice
sequence menu_opts

menu_opts = {"Name details", "Purchase and sale details", "Label details", "Type", "Delete from database", "Quit"}

current_choice = 1
while 1 do
        SetSize(10, 40)
        position(8,8)
        SetColors(BRIGHT_WHITE, GREEN)
        choice = Select(selected_item[PROD_ITEM], current_choice, menu_opts)

        current_choice = choice

        if choice = -1 or choice = 6 then exit end if

        if choice = 1 then
                selected_item = drug_options_name(selected_item)
        elsif choice = 2 then
                selected_item = drug_options_sale(selected_item)
        elsif choice = 3 then
                selected_item = drug_options_label(selected_item)
        elsif choice = 4 then
                selected_item = drug_options_type(selected_item)
                if selected_item[PROD_TYPE][1] = 'S' then --the type has changed
                        exit
                end if
    elsif choice = 5 then
        delete_item(selected_item)
        selected_item = {}
        exit
        end if

end while

--tidy the sreen
position(4,1) SetSize(SCREEN_LINES-4,SCREEN_COLS) SetColors(WHITE, BLACK) SetStyle(5) MessageBox("", {}) SetStyle(1)

--clear the box
--SetSize(14, 40) position(8,8) SetColors(WHITE, BLACK) SetStyle(5) MessageBox("",{}) SetStyle(1)

--update the database

return selected_item
end function


------------------------------------------------------------------------------------
function edit_product()
------------------------------------------------------------------------------------
--select the product to edit
--fill the relevant fields
-- go on to the same entry forms for adding a product / service
sequence str, matching_items, selected_item, matching_prods
integer choice, current_choice

matching_items = {}
selected_item = {}
matching_prods = {}


--enter the search string
position(  (SCREEN_LINES/2) - 3, (SCREEN_COLS/2) - 30/2)
SetSize(5, 30)
SetColors(BRIGHT_WHITE, BLUE)

str = Form("Search for an item",{"", "", 20})
str = remove_trailing_spaces(str[1])

if length(str) = 0 then
        return 0
end if

--search for the product        
matching_prods = query_database("xprods.sql", "SELECT * FROM Products where item LIKE '" & str & "%' ORDER BY item")

if length(matching_prods) = 0 then
        VOID = get_yn_box("Sorry, no matches.")
        return 0
end if

--now create a list of matching items
for i = 2 to length(matching_prods) do
        matching_items = append(matching_items, matching_prods[i][PROD_ITEM])
end for


--now display list of items to select one


current_choice = 1
while 1 do
        SetSize(14, 40)
        position(8, 8)
        SetColors(BRIGHT_WHITE, BLUE)
        choice = ListBoxIndex("Select", matching_items, current_choice)

        current_choice = choice
        
        if choice = -1 then exit end if
        
        if choice > 0 then
                selected_item = data_validate_product(matching_prods[choice+1]) --because of the data query title line
                exit
        end if
        
end while
SetSize(14, 40) position(8,8) SetColors(WHITE, BLACK) SetStyle(5) MessageBox("",{}) SetStyle(1)

--now go and edit / view selected item
if selected_item[PROD_TYPE][1] = 'D' then
        selected_item = drug_options_menu(selected_item)
else
        selected_item = service_options_menu(selected_item)
end if

--deleted?
if length(selected_item) = 0 then return 0 end if

--save any changes
if upper(get_yn_box(" Save changes? (y/n)[n] ")) = 'Y' then
    selected_item = data_validate_product(selected_item)
        data_update_product(selected_item)

end if

return 0
end function



------------------------------------------------------------------------------------
global procedure services_and_drugs()
------------------------------------------------------------------------------------
integer choice, current_choice

current_choice = 1
choice = 1

--set the menu
while 1 do
        position (7,7)
        SetColors(BLACK, YELLOW)
        SetSize(11,25)
        choice = Select("Services and drugs", current_choice,
                                {"Add",
                                 "Edit / examine",
                                 "Price list",
                                 "Reports",
                                 "Ordering / price updates",
                                 "Categories",
                                 "Price increases",
                                 "Quit"})
        
        current_choice = choice

    if choice = 8 or choice = -1 then
                position(7,7) SetSize(11,25) SetColors(WHITE, BLACK) SetStyle(5) MessageBox("", {}) SetStyle(1)
            exit
    end if 
    
    if choice = 2 then
            VOID = edit_product()
    elsif choice = 1 then
            add_item()
    elsif choice = 3 then
        VOID = price_list()
    elsif choice = 6 then
        VOID = assign_categories()    
    end if

end while

end procedure
