	tr = CurPatient[PA_OUTS_BAL] - tr
	
	--if tr is positive then amount tendered was less then patient balance - none left over
	--if tr is 0 then amount tendered is equal to patient balance - none left over
	--if tr is -ve then amount tendered was greater than this patient - have some left over for other patients
	
	if tr >= 0 then
		--just adjust this patient, the notes, and the client
		--don't need to do anything else
		CurPatient[PA_DRUGS]    = CurPatient[PA_DRUGS] 	- CurPatient[PA_DRUGS]/CurPatient[PA_OUTS_BAL] * tendered
		CurPatient[PA_VAT] 	= CurPatient[PA_VAT] 	- CurPatient[PA_VAT]/CurPatient[PA_OUTS_BAL] * tendered
		CurPatient[PA_FEES] 	= CurPatient[PA_FEES] 	- CurPatient[PA_FEES]/CurPatient[PA_OUTS_BAL] * tendered
		CurPatient[PA_OUTS_BAL] = CurPatient[PA_DRUGS] + CurPatient[PA_VAT] + CurPatient[PA_FEES]
	
		--update the patient
		data_update_patient()
	
		--update the patientlist entry
		patientlist[selected_patient] = CurPatient
	
		--put a note on the notes
		new_note[N_PATIENT_NO] = CurPatient[PA_PATIENT_NO]
		new_note[N_FEES] = CurPatient[PA_FEES]
		new_note[N_DRUGS] = CurPatient[PA_DRUGS]
		new_note[N_VAT] = CurPatient[PA_VAT]
		new_note[N_TOTAL] = CurPatient[PA_OUTS_BAL]
		new_note[N_NOTE] = sprintf("Paid by %s tendered %-9.2f", {paid_by, tendered} )
		data_insert_note(new_note)
	else
		--amt tendered is greater than this patient, so will have some left over for others
		--this patient can be set to zero, can then go through list taking off remaining amount as want
		
		--first put a note on the notes
		new_note[N_PATIENT_NO] = CurPatient[PA_PATIENT_NO]
		new_note[N_FEES] = CurPatient[PA_FEES]
		new_note[N_DRUGS] = CurPatient[PA_DRUGS]
		new_note[N_VAT] = CurPatient[PA_VAT]
		new_note[N_TOTAL] = CurPatient[PA_OUTS_BAL]
		new_note[N_NOTE] = sprintf("Paid by %s tendered %-9.2f", {paid_by, tendered} )
		data_insert_note(new_note)

		--set the amount remaining		
		tr = tendered - CurPatient[PA_OUTS_BAL]
		
		--update the patient		
		CurPatient[PA_DRUGS]    = 0
		CurPatient[PA_VAT] 	= 0
		CurPatient[PA_FEES] 	= 0
		CurPatient[PA_OUTS_BAL] = 0
		--update the patient
		data_update_patient()
		
		--now go through all the other patients
		for i = 1 to length(patientlist) do
			CurPatient = data_validate_patient(patientlist[i])
			if CurPatient[PA_OUTS_BAL] > 0 and tr > 0 then
				pr_rem = CurPatient[PA_OUTS_BAL] - tr
				if pr_rem >= 0 then
					--this means that patient outs bal is greater or equal to amount remaining
					CurPatient[PA_DRUGS]    = CurPatient[PA_DRUGS] 	- CurPatient[PA_DRUGS]/CurPatient[PA_OUTS_BAL] * tr
					CurPatient[PA_VAT] 	= CurPatient[PA_VAT] 	- CurPatient[PA_VAT]/CurPatient[PA_OUTS_BAL] * tr
					CurPatient[PA_FEES] 	= CurPatient[PA_FEES] 	- CurPatient[PA_FEES]/CurPatient[PA_OUTS_BAL] * tr
					CurPatient[PA_OUTS_BAL] = CurPatient[PA_DRUGS] + CurPatient[PA_VAT] + CurPatient[PA_FEES]
					
					data_update_patient()
					
					patientlist[selected_patient] = CurPatient
					
					--put a note on the notes
					new_note[N_PATIENT_NO] = CurPatient[PA_PATIENT_NO]
					new_note[N_FEES] = CurPatient[PA_FEES]
					new_note[N_DRUGS] = CurPatient[PA_DRUGS]
					new_note[N_VAT] = CurPatient[PA_VAT]
					new_note[N_TOTAL] = CurPatient[PA_OUTS_BAL]
					new_note[N_NOTE] = sprintf("Paid by %s tendered %-9.2f", {paid_by, tendered} )
					data_insert_note(new_note)

					--as all remaining part of tendered used up now			
					tr = 0
				else 	-- < 0
					--this means amount remaining is greater the patient outs bal, will have some left over
					--first put a note on the notes
					new_note[N_PATIENT_NO] = CurPatient[PA_PATIENT_NO]
					new_note[N_FEES] = CurPatient[PA_FEES]
					new_note[N_DRUGS] = CurPatient[PA_DRUGS]
					new_note[N_VAT] = CurPatient[PA_VAT]
					new_note[N_TOTAL] = CurPatient[PA_OUTS_BAL]
					new_note[N_NOTE] = sprintf("Paid by %s tendered %-9.2f", {paid_by, tendered} )
					data_insert_note(new_note)
			
					--set the amount remaining		
					tr = tendered - CurPatient[PA_OUTS_BAL]
					
					--update the patient		
					CurPatient[PA_DRUGS]    = 0
					CurPatient[PA_VAT] 	= 0
					CurPatient[PA_FEES] 	= 0
					CurPatient[PA_OUTS_BAL] = 0
					--update the patient
					data_update_patient()
				end if				
			end if
		end for
	
	end if
